import javax.mail.*;
import javax.mail.internet.*;
import java.util.*;
import javax.activation.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

public class RemoteMail extends HttpServlet implements Runnable {

	String returnMsg="";
	String log="";
    Thread t ;
	String[] to_list;
	String[] cc={};
	String[] bcc={};
	String[] attach_files;
	String subject;
	String text;
	Writer out;
	
	public void init() {
    }
	
    public void doGet(HttpServletRequest request, HttpServletResponse response) 
		throws ServletException, IOException {
        
        processRequest(request,response);	    
    }
    
    public void doPost(HttpServletRequest request,HttpServletResponse response) 
		throws ServletException, IOException {
        
        processRequest(request,response);
    }
	
	protected void processRequest(HttpServletRequest request, HttpServletResponse response)
		throws ServletException, IOException {
		out = response.getWriter();
		try{
		
			int len = request.getContentLength();
            String contentType = request.getContentType();
            System.out.println("Len: " + len);
            System.out.println("Type: "+ contentType);
             
            int bytesRead = 0;
            String remoteHost = request.getRemoteHost();
            String userAgent = request.getHeader("user-agent");
            System.out.println("Accessed at " + (new Date()) + " from " + remoteHost
               + ", using " + userAgent);
			   
			System.out.println("===Getting the mail parameters===");
			
			
			
			String to = request.getParameter("MAIL$TO");
			
			/*BufferedReader br = request.getReader();
			String Data = br.readLine();
			System.out.println("Data :"+Data); */
			
			subject = request.getParameter("SUBJECT");
			text = request.getParameter("BODYTEXT");
			String attach = request.getParameter("ATTACHMENTS");
			
			System.out.println("===All parameter values===");
			Enumeration e = request.getParameterNames();
            while (e.hasMoreElements()) {
				String param = (String)e.nextElement();
				String value = (String)request.getParameter(param);
				System.out.println("Parameter: "+param+"\nValue: "+value);
			}
			
			//splitting the to and file attachment paths
			
			to_list = to.split(";");
			attach_files = attach.split(";");
			
			for(int i=0;i<to_list.length;i++)
				System.out.println(to_list[i]);
			
			for(int i=0;i<attach_files.length;i++)
				System.out.println(attach_files[i]);
				
			System.out.println("To list:" +to);
			System.out.println("Subject: "+ subject);
			System.out.println("Body Text: "+ text);
			System.out.println("Attachment paths: "+attach );
			
			//t = new Thread(this);
			//t.start();
			run();
			out.write("RemoteMail invoked..");
			out.flush();
			
		}catch(Exception e){
			System.out.println("Exception caught in processRequest() " +e.toString());
		}
		
	}
	
	 public void run() {
		
		try{
			boolean sent = sendMail("mobileremoteshell@gmail.com","itdepartment",
                        "smtp.gmail.com","465","true","true",true,
                        "javax.net.ssl.SSLSocketFactory","false",to_list,cc,bcc,
                        subject,text,attach_files);
		    
			return;
			}catch(Exception e){
			
				System.out.println("Exception in run() "+e.toString());
				try{
					out.write("Error in sending mail.. please try again later");
					out.flush();
					}catch(IOException ex)
					{
						System.out.println(ex.toString());
					}
			}
	 }
	
	public synchronized boolean sendMail(String userName,String passWord,
                                String host,String port,String starttls,String auth,boolean debug,
                                String socketFactoryClass,String fallback,String[] to,String[] cc,String[] bcc,
                                String subject,String text,String[] attach_files){
		
        Properties props = new Properties();
		
		if(!"".equals(port))
            props.put("mail.smtp.port", port);
		if(!"".equals(starttls))
            props.put("mail.smtp.starttls.enable",starttls);
            props.put("mail.smtp.auth", auth);
		if(debug){
            props.put("mail.smtp.debug", "true");
		}else{
            props.put("mail.smtp.debug", "false");		
		}
		if(!"".equals(port))
            props.put("mail.smtp.socketFactory.port", port);
		if(!"".equals(socketFactoryClass))
            props.put("mail.smtp.socketFactory.class",socketFactoryClass);
		if(!"".equals(fallback))
            props.put("mail.smtp.socketFactory.fallback", fallback);
 
        try
        {
            Session session = Session.getInstance(props, null);
            session.setDebug(debug); 
            MimeMessage msg = new MimeMessage(session);
                                
            //Mailer list
            
            for(int i=0;i<to.length;i++){
                msg.addRecipient(Message.RecipientType.TO, new InternetAddress(to[i]));
			}
			for(int i=0;i<cc.length;i++){
                msg.addRecipient(Message.RecipientType.CC, new InternetAddress(cc[i]));
			}
            for(int i=0;i<bcc.length;i++){
                msg.addRecipient(Message.RecipientType.BCC, new InternetAddress(bcc[i]));
            }
            
			//Mail Subject 
            msg.setSubject(subject);
            
            // create and fill the first message part
			System.out.println(attach_files.length +"\n\n\n");
			
            if(!attach_files[0].startsWith("null"))
			{
				MimeBodyPart mbp_body = new MimeBodyPart();
            	mbp_body.setText(text+"\n\n\n\n\n\n\n\n\n\n\n\n -Sent Using MobileRemoteShell");

				Multipart mp = new MimeMultipart();
				mp.addBodyPart(mbp_body);
                        
				// create the second message part
						
				MimeBodyPart[] mbp = new MimeBodyPart[attach_files.length];
				String notSent = "" ;
				for(int i=0 ; i<attach_files.length;i++)
				{
					// attach the file to the message
					mbp[i] = new MimeBodyPart();
					File f = new File(attach_files[i]);
					if(f.length()<100000) //size less than 100KB
					{
						mbp[i].attachFile(f);
						mp.addBodyPart(mbp[i]);
					}
					else
					{
						notSent += attach_files[i]+"\n" ;  
						continue;
					}
						//FileDataSource fds = new FileDataSource("c:/mail/"+filename[i]);
						//mbp2.setDataHandler(new DataHandler(fds));
						//mbp2.setFileName(fds.getName());
                           
				}
				System.out.println("Following files could not be sent(Size>100KB) " + "\n"+notSent);
				msg.setContent(mp);
            }
			else{ 
				msg.setText(text+"\n\n\n\n\n\n\n\n\n\n\n\n -Sent Using MobileRemoteShell");
			}
            // add the Multipart to the message
            msg.saveChanges();
            
                    
            Transport transport = session.getTransport("smtp");
            transport.connect(host, userName, passWord);
            transport.sendMessage(msg, msg.getAllRecipients());
            transport.close();
			
			System.out.println("Mail sent Successfully @" +new Date());
			out.write("Mail sent Successfully @" +new Date());
			out.flush();
            
			return true;
        }
        catch (Exception mex)
        {
            mex.printStackTrace();
			System.out.println("Error sending mail.. "+mex.toString());
			try{
				out.write("Error sending mail, try again later!!");
				out.flush();
				}catch(IOException e){
					System.out.println(e.toString());
				}
			return false;
        } 
	 }

}

